import { merge, EMPTY, Subject } from 'rxjs'
import { catchError, finalize, ignoreElements, tap, } from 'rxjs/operators'
export function bindStdinData(stdin, inputData$) {
    const err$ = new Subject()
    const input$ = inputData$.pipe(tap(data => {
        // console.log('bindStdinData:', data)
        // debug in vsc below will cause EPIPE error
        stdin.write(data, err => {
            if (err) {
                err$.next(err)
            }
        })
    }), catchError((err) => {
        err$.next(err)
        return EMPTY
    }), ignoreElements(), finalize(() => {
        stdin.end()
        err$.complete()
    }))
    const ret$ = merge(err$.asObservable(), input$).pipe(tap((err) => {
        throw err
    }))

    return ret$
}
